automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

FYI: comments and += (WAS: Re: misinterpreted comment)


From: Alexandre Duret-Lutz
Subject: FYI: comments and += (WAS: Re: misinterpreted comment)
Date: Tue, 21 Sep 2004 21:25:54 +0200
User-agent: Gnus/5.1003 (Gnus v5.10.3) Emacs/21.3.50 (gnu/linux)

>>> "Stepan" == Stepan Kasal <address@hidden> writes:

 Stepan> Hello,
 Stepan> a Makefile.am contained the following:

 Stepan> SUBDIRS = goffice # egg
 Stepan> if WITH_GTK
 Stepan> SUBDIRS += foocanvas
 Stepan> endif

 Stepan> which yielded the following in Makefile.in

 Stepan> SUBDIRS = goffice # egg $(am__append_1)

Thank you for reporting this.  I'm checking this in.

2004-09-21  Alexandre Duret-Lutz  <address@hidden>

        * lib/Automake/VarDef.pm (append): Strip comments from augmented
        variables.
        * tests/comment8.test: New file.
        * tests/Makefile.am (TESTS): Add comment8.test.
        Report from Stepan Kasal.

Index: lib/Automake/VarDef.pm
===================================================================
RCS file: /cvs/automake/automake/lib/Automake/VarDef.pm,v
retrieving revision 1.5
diff -u -r1.5 VarDef.pm
--- lib/Automake/VarDef.pm      24 Apr 2004 14:18:52 -0000      1.5
+++ lib/Automake/VarDef.pm      21 Sep 2004 18:25:08 -0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2003  Free Software Foundation, Inc.
+# Copyright (C) 2003, 2004  Free Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -178,6 +178,16 @@
   $self->{'comment'} .= $comment;
 
   my $val = $self->{'value'};
+
+  # Strip comments from augmented variables.  This is so that
+  #   VAR = foo # com
+  #   VAR += bar
+  # does not become
+  #   VAR = foo # com bar
+  # Furthermore keeping `#' would not be portable if the variable is
+  # output on multiple lines.
+  $val =~ s/ ?#.*//;
+
   if (chomp $val)
     {
       # Insert a backslash before a trailing newline.
Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.565.2.3
diff -u -r1.565.2.3 Makefile.am
--- tests/Makefile.am   10 Sep 2004 18:38:33 -0000      1.565.2.3
+++ tests/Makefile.am   21 Sep 2004 18:25:09 -0000
@@ -93,6 +93,7 @@
 comment5.test \
 comment6.test \
 comment7.test \
+comment8.test \
 compile.test \
 compile_f90_c_cxx.test \
 compile_f_c_cxx.test \
Index: tests/comment8.test
===================================================================
RCS file: tests/comment8.test
diff -N tests/comment8.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/comment8.test 21 Sep 2004 18:25:09 -0000
@@ -0,0 +1,53 @@
+#! /bin/sh
+# Copyright (C) 2004  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Automake; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Make sure += does not append to a comment.
+# Report from Stepan Kasal.
+
+. ./defs || exit 1
+
+set -e
+
+cat >> configure.in <<'EOF'
+AM_CONDITIONAL([COND1], [true])
+AM_CONDITIONAL([COND2], [true])
+AC_OUTPUT
+EOF
+
+cat > Makefile.am << 'EOF'
+VAR = valA# comA ## com C
+VAR += valB # comB
+if COND1
+  VAR += val1 # com1
+endif COND1
+VAR += valC
+if COND2
+  VAR += val2 # com2
+endif COND2
+
+test:
+       test "`echo $(VAR)`" = 'valA valB val1 valC val2'
+EOF
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE
+./configure
+make test

-- 
Alexandre Duret-Lutz





reply via email to

[Prev in Thread] Current Thread [Next in Thread]